﻿Imports System.Net.Http
Imports System.Net.Http.Headers
Imports Newtonsoft.Json
Imports Newtonsoft.Json.Linq

Imports System.Web.HttpUtility
Imports System.Net
Imports System.Text
Imports System.Drawing
Imports System.Text.RegularExpressions



Public Class Form1

    Public Shared AuftragIDvenabo As Int64
    Public Shared WartungsvertragIDvenabo As Int64

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click


        tbAusgabe.Text = getJSONData(tbAPI.Text, tbURL.Text, "/api/v1/work_orders", "?offset=1&amp;limit=10")

    End Sub

    Public Shared Function getJSONData(AktToken As String, base_url As String, api_Url As String, urL_parameter As String) As String


        ServicePointManager.ServerCertificateValidationCallback = New System.Net.Security.RemoteCertificateValidationCallback(AddressOf AcceptCert)
        ServicePointManager.Expect100Continue = True
        ServicePointManager.SecurityProtocol = SecurityProtocolType.Tls12

        Dim ClientCert As New System.Security.Cryptography.X509Certificates.X509Certificate
        ClientCert = GetSSLCertificate(base_url)

        If IsNothing(urL_parameter) Then
            urL_parameter = ""
        Else
            If urL_parameter.Contains("?") = False And urL_parameter.Contains("&") = True Then

                Dim regex As Regex = New Regex("&")
                urL_parameter = regex.Replace(urL_parameter, "?", 1)

            End If

        End If

        Dim request As HttpWebRequest = TryCast(WebRequest.Create(base_url + api_Url + urL_parameter), HttpWebRequest)

        If IsNothing(ClientCert) = False Then
            request.ClientCertificates.Add(ClientCert)
        End If


        request.Headers.Add("x-api-token", AktToken)


        Dim response As HttpWebResponse = TryCast(request.GetResponse(), HttpWebResponse)
        Dim dataStream As IO.Stream = response.GetResponseStream()
        Dim reader As New IO.StreamReader(dataStream)
        Dim responseFromServer As String = reader.ReadToEnd()
        Dim result = responseFromServer
        reader.Close()
        response.Close()
        Return result
    End Function



    Public Shared Function AcceptCert(ByVal sender As Object, ByVal cert As System.Security.Cryptography.X509Certificates.X509Certificate, _
                        ByVal chain As System.Security.Cryptography.X509Certificates.X509Chain, _
                        ByVal errors As System.Net.Security.SslPolicyErrors) As Boolean
        Return True
    End Function

    Public Shared Function GetSSLCertificate(url As String) As System.Security.Cryptography.X509Certificates.X509Certificate

        Dim u As Uri = New Uri(url)
        Dim sp As ServicePoint = ServicePointManager.FindServicePoint(u)

        Dim groupName As String = Guid.NewGuid().ToString()
        Dim req As HttpWebRequest = HttpWebRequest.Create(u)
        req.ConnectionGroupName = groupName

        Using resp As WebResponse = req.GetResponse()

            sp.CloseConnectionGroup(groupName)
            Return sp.Certificate
        End Using


    End Function

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        tbAPI.Text = "c452bbb9-59f2-4ffd-8d5e-f69ae0821445"
        tbURL.Text = "https://fabianversiontest.venabo.cloud"



    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click

        tbAusgabe.Text = getJSONData(tbAPI.Text, tbURL.Text, "/api/v1/work_order_booking_activity_sum", "")

    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        tbAusgabe.Text = getJSONData(tbAPI.Text, tbURL.Text, "/api/v1/work_order_stamp_activity_sum", "")
    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        tbAusgabe.Text = getJSONData(tbAPI.Text, tbURL.Text, "/api/v1/activities", "")
    End Sub

    Private Sub btnAuftragErstellen_Click(sender As Object, e As EventArgs) Handles btnAuftragErstellen.Click

        Dim jsonSring = tbAusgabe.Text

        Dim data = Encoding.UTF8.GetBytes(jsonSring)
        tbAusgabe.Text = SendRequest(tbAPI.Text, tbURL.Text, "/api/v1/work_orders", "", data, "application/json", "POST")



    End Sub

    Private Sub btnAuftragBearbeiten_Click(sender As Object, e As EventArgs) Handles btnAuftragBearbeiten.Click
        tbAusgabe.Text = "{""name"":""Neuer Name vom Testauftrag"",""description"":""Beschreibung vom Auftrag"",""reference"":""TESTAB123"",""targetTime"":36000,""allEmployees"":true,""allActivities"":true,""allStampDevices"":true,""includeOperationSchedules"":true,""settlementType"":""TIME_INPUT"",""statusId"":4, ""parentId"":null}"

        Dim jsonSring = tbAusgabe.Text

        Dim data = Encoding.UTF8.GetBytes(jsonSring)
        If AuftragIDvenabo > 0 Then
            tbAusgabe.Text = SendRequest(tbAPI.Text, tbURL.Text, "/api/v1/work_orders/" + AuftragIDvenabo.ToString, "", data, "application/json", "PUT")
        Else
            MsgBox("Keine Auftrags-ID vorhanden, bitte erst Auftrags-ID abrufen")
        End If
     
    End Sub

    Private Sub btnAuftragLoeschen_Click(sender As Object, e As EventArgs) Handles btnAuftragLoeschen.Click
        Dim data = Encoding.UTF8.GetBytes("{}")
        If AuftragIDvenabo > 0 Then
        Else
            MsgBox("Keine Auftrags-ID vorhanden, bitte erst Auftrags-ID abrufen")
        End If
        tbAusgabe.Text = SendRequest(tbAPI.Text, tbURL.Text, "/api/v1/work_orders/" + AuftragIDvenabo.ToString, "", data, "application/json", "DELETE")
    End Sub


    Private Function SendRequest(AktToken As String, base_url As String, api_Url As String, urL_parameter As String, jsonDataBytes As Byte(), contentType As String, method As String) As String
        ServicePointManager.ServerCertificateValidationCallback = New System.Net.Security.RemoteCertificateValidationCallback(AddressOf AcceptCert)
        ServicePointManager.Expect100Continue = True
        ServicePointManager.SecurityProtocol = SecurityProtocolType.Tls12

        Dim ClientCert As New System.Security.Cryptography.X509Certificates.X509Certificate
        ClientCert = GetSSLCertificate(base_url)


        Dim response As String


        Dim request As HttpWebRequest = TryCast(WebRequest.Create(base_url + api_Url + urL_parameter), HttpWebRequest)

        If IsNothing(ClientCert) = False Then
            request.ClientCertificates.Add(ClientCert)
        End If


        request.Headers.Add("x-api-token", AktToken)


        ' request = WebRequest.Create(uri)
        request.ContentLength = jsonDataBytes.Length
        request.ContentType = contentType
        request.Method = method

        Try
            Using requestStream = request.GetRequestStream
                requestStream.Write(jsonDataBytes, 0, jsonDataBytes.Length)
                requestStream.Close()

                Using responseStream = request.GetResponse.GetResponseStream
                    Using reader As New IO.StreamReader(responseStream)
                        response = reader.ReadToEnd()
                    End Using
                End Using
            End Using
        Catch ex As Exception
            response = ex.Message
        End Try



        Return response
    End Function

    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click

        tbAusgabe.Text = "{""name"":""Testauftrag"",""description"":""Beschreibung vom Auftrag"",""reference"":""TESTAB123"",""targetTime"":36000,""allEmployees"":true,""allActivities"":true,""allStampDevices"":true,""includeOperationSchedules"":true,""settlementType"":""TIME_INPUT"",""statusId"":4, ""parentId"":null}"

    End Sub

    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click
        AuftragIDvenabo = 0
        Dim dt As DataTable

        tbAusgabe.Text = getJSONData(tbAPI.Text, tbURL.Text, "/api/v1/work_orders", "?filter[reference]=TESTAB123")

        dt = JsonConvert.DeserializeObject(Of DataTable)(tbAusgabe.Text)

        For Each row As DataRow In dt.Rows
            AuftragIDvenabo = row("id")
        Next

    End Sub

    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles Button7.Click


        AuftragIDvenabo = 0
        Dim dt As DataTable

        tbAusgabe.Text = getJSONData(tbAPI.Text, tbURL.Text, "/api/v1/work_orders", "?filter[reference]=AB12345")

        dt = JsonConvert.DeserializeObject(Of DataTable)(tbAusgabe.Text)

        For Each row As DataRow In dt.Rows
            AuftragIDvenabo = row("id")
        Next


        tbAusgabe.Text = getJSONData(tbAPI.Text, tbURL.Text, "/api/v1/work_order_stamp_activity_sum?filter[from]=2020-07-30&filter[to]=2020-07-31&filter[workOrderId]=" + AuftragIDvenabo.ToString, "")


        AuftragIDvenabo = 0

    End Sub

    Private Sub Button8_Click(sender As Object, e As EventArgs) Handles Button8.Click

        Dim dt As DataTable
        Dim addressId As Int64


        tbAusgabe.Text = getJSONData(tbAPI.Text, tbURL.Text, "/api/v1/phone_numbers?filter[phoneNumber]=0049262341989049", "")

        dt = JsonConvert.DeserializeObject(Of DataTable)(tbAusgabe.Text)

        For Each row As DataRow In dt.Rows
            addressId = row("addressId")
            tbAusgabe.Text += getJSONData(tbAPI.Text, tbURL.Text, "/api/v1/addresses/" + addressId.ToString, "")
        Next




    End Sub

    Private Sub Button9_Click(sender As Object, e As EventArgs)


        tbAusgabe.Text = getJSONData(tbAPI.Text, tbURL.Text, "/api/v1/objects", "?filter[reference]=")


        '        tbAusgabe.Text = getJSONData(tbAPI.Text, tbURL.Text, "/api/v1/service_contracts", "?filter[reference]=")


        'tbAusgabe.Text = "{""name"":""Testauftrag"",""description"":""Beschreibung vom Auftrag"",""reference"":""TESTAB123"",""targetTime"":36000,""allEmployees"":true,""allActivities"":true,""allStampDevices"":true,""includeOperationSchedules"":true,""settlementType"":""TIME_INPUT"",""statusId"":4, ""parentId"":null}"


    End Sub

    Private Sub Button11_Click(sender As Object, e As EventArgs)

        tbAusgabe.Text = ""


        Dim jsonSring = tbAusgabe.Text

        Dim data = Encoding.UTF8.GetBytes(jsonSring)
        tbAusgabe.Text = SendRequest(tbAPI.Text, tbURL.Text, "/api/v1/service_contracts", "", data, "application/json", "POST")



    End Sub

    Private Sub Button10_Click(sender As Object, e As EventArgs)

    End Sub

    Private Sub Button9_Click_1(sender As Object, e As EventArgs) Handles Button9.Click
        tbAusgabe.Text = getJSONData(tbAPI.Text, tbURL.Text, "/api/v1/employees", "?filter[reference]=")
    End Sub
End Class
